#!/usr/bin/env node
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var import_server = __toModule(require("../server"));
var import_pino = __toModule(require("pino"));
var import_pino_pretty = __toModule(require("pino-pretty"));
const logger = (0, import_pino.default)({
  level: process.env.DEBUG ? "debug" : "info"
}, (0, import_pino_pretty.default)({
  colorize: true,
  ignore: "pid,name,hostname",
  singleLine: true,
  messageFormat: (log, messageKey) => `${log["reqId"] ?? "NONE"} ${log["target"] ?? "NONE"} ${log[messageKey]}`
}));
(0, import_server.createDefaultServer)(logger).then((server) => {
  const hostname = process.env.HOST ?? "localhost";
  const port = parseInt(process.env.PORT ?? "9229", 10);
  return server.start({ hostname, port });
}).then((httpServer) => {
  const address = httpServer.address();
  if (!address) {
    throw new Error("Server started without address");
  }
  const url = typeof address === "string" ? address : `${address.address}:${address.port}`;
  logger.info(`Cognito Local running on http://${url}`);
}).catch((err) => {
  logger.error(err);
  process.exit(1);
});
