export declare class UnsupportedError extends Error {
}
export declare class CognitoError extends Error {
    readonly code: string;
    constructor(code: string, message: string);
}
export declare class NotAuthorizedError extends CognitoError {
    constructor();
}
export declare class UserNotFoundError extends CognitoError {
    constructor(message?: string);
}
export declare class UsernameExistsError extends CognitoError {
    constructor();
}
export declare class CodeMismatchError extends CognitoError {
    constructor();
}
export declare class InvalidPasswordError extends CognitoError {
    constructor();
}
export declare class PasswordResetRequiredError extends CognitoError {
    constructor();
}
export declare class ResourceNotFoundError extends CognitoError {
    constructor(message?: string);
}
export declare class GroupNotFoundError extends ResourceNotFoundError {
    constructor();
}
export declare class UnexpectedLambdaExceptionError extends CognitoError {
    constructor();
}
export declare class UserLambdaValidationError extends CognitoError {
    constructor(message?: string);
}
export declare class InvalidLambdaResponseError extends CognitoError {
    constructor();
}
export declare class InvalidParameterError extends CognitoError {
    constructor(message?: string);
}
