var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  CryptoService: () => CryptoService
});
var import_client_node = __toModule(require("@aws-crypto/client-node"));
var import_aws_sdk = __toModule(require("aws-sdk"));
const { encrypt } = (0, import_client_node.buildClient)(import_client_node.CommitmentPolicy.REQUIRE_ENCRYPT_ALLOW_DECRYPT);
class CryptoService {
  constructor(config) {
    this.config = config;
  }
  get keyringNode() {
    if (this._keyringNode) {
      return this._keyringNode;
    }
    if (!this.config || !this.config.KMSKeyAlias || !this.config.KMSKeyId) {
      throw new Error("KMSConfig.KMSKeyAlias and KMSConfig.KMSKeyId is required when using a CustomEmailSender trigger.");
    }
    const _a = this.config, { KMSKeyId, KMSKeyAlias } = _a, clientConfig = __objRest(_a, ["KMSKeyId", "KMSKeyAlias"]);
    const generatorKeyId = KMSKeyAlias;
    const keyIds = [KMSKeyId];
    return this._keyringNode = new import_client_node.KmsKeyringNode({
      generatorKeyId,
      keyIds,
      clientProvider: () => new import_aws_sdk.KMS(clientConfig)
    });
  }
  async encrypt(ctx, plaintext) {
    ctx.logger.debug({ plaintext }, "encrypting code");
    const { result } = await encrypt(this.keyringNode, plaintext);
    const encryptedCode = result.toString("base64");
    ctx.logger.debug({ encryptedCode }, "code succesfully encrypted");
    return encryptedCode;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CryptoService
});
