import { Context } from "./context";
import { DeliveryDetails, MessageDelivery } from "./messageDelivery/messageDelivery";
import { Triggers } from "./triggers";
import { User } from "./userPoolService";
export interface Message {
    __code?: string;
    emailMessage?: string;
    emailSubject?: string;
    smsMessage?: string;
}
declare type MessageSource = "AdminCreateUser" | "Authentication" | "ForgotPassword" | "ResendCode" | "SignUp" | "UpdateUserAttribute" | "VerifyUserAttribute";
export interface Messages {
    deliver(ctx: Context, source: MessageSource, clientId: string | null, userPoolId: string, user: User, code: string, clientMetadata: Record<string, string> | undefined, deliveryDetails: DeliveryDetails): Promise<void>;
}
export declare class MessagesService implements Messages {
    private readonly triggers;
    private readonly messageDelivery;
    constructor(triggers: Triggers, messageDelivery: MessageDelivery);
    deliver(ctx: Context, source: MessageSource, clientId: string | null, userPoolId: string, user: User, code: string, clientMetadata: Record<string, string> | undefined, deliveryDetails: DeliveryDetails): Promise<void>;
    private create;
    private customDelivery;
}
export {};
