var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  AdminConfirmSignUp: () => AdminConfirmSignUp
});
var import_errors = __toModule(require("../errors"));
var import_userPoolService = __toModule(require("../services/userPoolService"));
const AdminConfirmSignUp = ({
  clock,
  cognito,
  triggers
}) => async (ctx, req) => {
  const userPool = await cognito.getUserPool(ctx, req.UserPoolId);
  const user = await userPool.getUserByUsername(ctx, req.Username);
  if (!user) {
    throw new import_errors.NotAuthorizedError();
  }
  const updatedUser = __spreadProps(__spreadValues({}, user), {
    UserLastModifiedDate: clock.get(),
    UserStatus: "CONFIRMED"
  });
  await userPool.saveUser(ctx, updatedUser);
  if (triggers.enabled("PostConfirmation")) {
    await triggers.postConfirmation(ctx, {
      source: "PostConfirmation_ConfirmSignUp",
      clientId: null,
      clientMetadata: req.ClientMetadata,
      username: updatedUser.Username,
      userPoolId: req.UserPoolId,
      userAttributes: (0, import_userPoolService.attributesAppend)(updatedUser.Attributes, (0, import_userPoolService.attribute)("cognito:user_status", updatedUser.UserStatus))
    });
  }
  return {};
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AdminConfirmSignUp
});
