var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  CreateUserPool: () => CreateUserPool
});
var import_short_uuid = __toModule(require("short-uuid"));
var import_cognitoService = __toModule(require("../services/cognitoService"));
var import_responses = __toModule(require("./responses"));
const REGION = "local";
const ACCOUNT_ID = "local";
const generator = (0, import_short_uuid.default)("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
const createSchemaAttributes = (defaultAttributes, requestSchema) => {
  const overrides = Object.fromEntries(requestSchema.map((x) => [x.Name, x]));
  const defaultAttributeNames = defaultAttributes.map((x) => x.Name);
  const overriddenAttributes = defaultAttributes.map((attr) => {
    if (!attr.Name) {
      return attr;
    }
    const override = overrides[attr.Name];
    return __spreadValues(__spreadValues({}, attr), override);
  });
  const customAttributes = requestSchema.filter((x) => !defaultAttributeNames.includes(x.Name)).map((attr) => {
    const type = attr.AttributeDataType ?? "String";
    return {
      Name: `custom:${attr.Name}`,
      AttributeDataType: type,
      DeveloperOnlyAttribute: attr.DeveloperOnlyAttribute ?? false,
      Mutable: attr.Mutable ?? true,
      Required: attr.Required ?? false,
      StringAttributeConstraints: type === "String" ? attr.StringAttributeConstraints ?? {} : void 0,
      NumberAttributeConstraints: type === "Number" ? attr.NumberAttributeConstraints ?? {} : void 0
    };
  });
  return [...overriddenAttributes, ...customAttributes];
};
const CreateUserPool = ({ cognito, clock }) => async (ctx, req) => {
  const now = clock.get();
  const userPoolId = `${REGION}_${generator.new().slice(0, 8)}`;
  const userPool = await cognito.createUserPool(ctx, {
    AccountRecoverySetting: req.AccountRecoverySetting,
    AdminCreateUserConfig: req.AdminCreateUserConfig,
    AliasAttributes: req.AliasAttributes,
    Arn: `arn:aws:cognito-idp:${REGION}:${ACCOUNT_ID}:userpool/${userPoolId}`,
    AutoVerifiedAttributes: req.AutoVerifiedAttributes,
    CreationDate: now,
    DeviceConfiguration: req.DeviceConfiguration,
    EmailConfiguration: req.EmailConfiguration,
    EmailVerificationMessage: req.EmailVerificationMessage,
    EmailVerificationSubject: req.EmailVerificationSubject,
    Id: userPoolId,
    LambdaConfig: req.LambdaConfig,
    LastModifiedDate: now,
    MfaConfiguration: req.MfaConfiguration,
    Name: req.PoolName,
    Policies: req.Policies,
    SchemaAttributes: createSchemaAttributes(import_cognitoService.USER_POOL_AWS_DEFAULTS.SchemaAttributes ?? [], req.Schema ?? []),
    SmsAuthenticationMessage: req.SmsAuthenticationMessage,
    SmsConfiguration: req.SmsConfiguration,
    SmsVerificationMessage: req.SmsVerificationMessage,
    UsernameAttributes: req.UsernameAttributes,
    UsernameConfiguration: req.UsernameConfiguration,
    UserPoolAddOns: req.UserPoolAddOns,
    UserPoolTags: req.UserPoolTags,
    VerificationMessageTemplate: req.VerificationMessageTemplate
  });
  return {
    UserPool: (0, import_responses.userPoolToResponseObject)(userPool)
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CreateUserPool
});
