var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  CreateUserPoolClient: () => CreateUserPoolClient
});
var import_appClient = __toModule(require("../services/appClient"));
var import_responses = __toModule(require("./responses"));
const CreateUserPoolClient = ({
  clock,
  cognito
}) => async (ctx, req) => {
  var _a, _b, _c;
  const userPool = await cognito.getUserPool(ctx, req.UserPoolId);
  const appClient = {
    AccessTokenValidity: req.AccessTokenValidity,
    AllowedOAuthFlows: req.AllowedOAuthFlows,
    AllowedOAuthFlowsUserPoolClient: req.AllowedOAuthFlowsUserPoolClient,
    AllowedOAuthScopes: req.AllowedOAuthScopes,
    AnalyticsConfiguration: req.AnalyticsConfiguration,
    CallbackURLs: req.CallbackURLs,
    ClientId: (0, import_appClient.newId)(),
    ClientName: req.ClientName,
    ClientSecret: req.GenerateSecret ? (0, import_appClient.newId)() : void 0,
    CreationDate: clock.get(),
    DefaultRedirectURI: req.DefaultRedirectURI,
    EnableTokenRevocation: req.EnableTokenRevocation,
    ExplicitAuthFlows: req.ExplicitAuthFlows,
    IdTokenValidity: req.IdTokenValidity,
    LastModifiedDate: clock.get(),
    LogoutURLs: req.LogoutURLs,
    PreventUserExistenceErrors: req.PreventUserExistenceErrors,
    ReadAttributes: req.ReadAttributes,
    RefreshTokenValidity: req.RefreshTokenValidity,
    SupportedIdentityProviders: req.SupportedIdentityProviders,
    TokenValidityUnits: {
      AccessToken: ((_a = req.TokenValidityUnits) == null ? void 0 : _a.AccessToken) ?? "hours",
      IdToken: ((_b = req.TokenValidityUnits) == null ? void 0 : _b.IdToken) ?? "minutes",
      RefreshToken: ((_c = req.TokenValidityUnits) == null ? void 0 : _c.RefreshToken) ?? "days"
    },
    UserPoolId: req.UserPoolId,
    WriteAttributes: req.WriteAttributes
  };
  await userPool.saveAppClient(ctx, appClient);
  return {
    UserPoolClient: (0, import_responses.appClientToResponseObject)(appClient)
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CreateUserPoolClient
});
