var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  GetUser: () => GetUser
});
var import_jsonwebtoken = __toModule(require("jsonwebtoken"));
var import_errors = __toModule(require("../errors"));
const GetUser = ({ cognito }) => async (ctx, req) => {
  const decodedToken = import_jsonwebtoken.default.decode(req.AccessToken);
  if (!decodedToken) {
    ctx.logger.info("Unable to decode token");
    throw new import_errors.InvalidParameterError();
  }
  const userPool = await cognito.getUserPoolForClientId(ctx, decodedToken.client_id);
  const user = await userPool.getUserByUsername(ctx, decodedToken.sub);
  if (!user) {
    throw new import_errors.UserNotFoundError();
  }
  return {
    MFAOptions: user.MFAOptions,
    PreferredMfaSetting: user.PreferredMfaSetting,
    UserAttributes: user.Attributes,
    UserMFASettingList: user.UserMFASettingList,
    Username: user.Username
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  GetUser
});
