var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  RespondToAuthChallenge: () => RespondToAuthChallenge
});
var import_errors = __toModule(require("../errors"));
const RespondToAuthChallenge = ({
  clock,
  cognito,
  triggers,
  tokenGenerator
}) => async (ctx, req) => {
  if (!req.ChallengeResponses) {
    throw new import_errors.InvalidParameterError("Missing required parameter challenge responses");
  }
  if (!req.ChallengeResponses.USERNAME) {
    throw new import_errors.InvalidParameterError("Missing required parameter USERNAME");
  }
  if (!req.Session) {
    throw new import_errors.InvalidParameterError("Missing required parameter Session");
  }
  const userPool = await cognito.getUserPoolForClientId(ctx, req.ClientId);
  const userPoolClient = await cognito.getAppClient(ctx, req.ClientId);
  const user = await userPool.getUserByUsername(ctx, req.ChallengeResponses.USERNAME);
  if (!user || !userPoolClient) {
    throw new import_errors.NotAuthorizedError();
  }
  if (req.ChallengeName === "SMS_MFA") {
    if (user.MFACode !== req.ChallengeResponses.SMS_MFA_CODE) {
      throw new import_errors.CodeMismatchError();
    }
    await userPool.saveUser(ctx, __spreadProps(__spreadValues({}, user), {
      MFACode: void 0,
      UserLastModifiedDate: clock.get()
    }));
  } else if (req.ChallengeName === "NEW_PASSWORD_REQUIRED") {
    if (!req.ChallengeResponses.NEW_PASSWORD) {
      throw new import_errors.InvalidParameterError("Missing required parameter NEW_PASSWORD");
    }
    await userPool.saveUser(ctx, __spreadProps(__spreadValues({}, user), {
      Password: req.ChallengeResponses.NEW_PASSWORD,
      UserLastModifiedDate: clock.get(),
      UserStatus: "CONFIRMED"
    }));
  } else {
    throw new import_errors.UnsupportedError(`respondToAuthChallenge with ChallengeName=${req.ChallengeName}`);
  }
  if (triggers.enabled("PostAuthentication")) {
    await triggers.postAuthentication(ctx, {
      clientId: req.ClientId,
      clientMetadata: req.ClientMetadata,
      source: "PostAuthentication_Authentication",
      userAttributes: user.Attributes,
      username: user.Username,
      userPoolId: userPool.options.Id
    });
  }
  const userGroups = await userPool.listUserGroupMembership(ctx, user);
  return {
    ChallengeParameters: {},
    AuthenticationResult: await tokenGenerator.generate(ctx, user, userGroups, userPoolClient, req.ClientMetadata, "Authentication")
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RespondToAuthChallenge
});
