var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  UpdateUserPoolClient: () => UpdateUserPoolClient
});
var import_errors = __toModule(require("../errors"));
var import_responses = __toModule(require("./responses"));
const UpdateUserPoolClient = ({
  clock,
  cognito
}) => async (ctx, req) => {
  var _a, _b, _c, _d, _e, _f;
  const userPool = await cognito.getUserPool(ctx, req.UserPoolId);
  const appClient = await cognito.getAppClient(ctx, req.ClientId);
  if (!appClient || appClient.UserPoolId !== req.UserPoolId) {
    throw new import_errors.ResourceNotFoundError();
  }
  const updatedAppClient = __spreadProps(__spreadValues({}, appClient), {
    AccessTokenValidity: req.AccessTokenValidity ?? appClient.AccessTokenValidity,
    AllowedOAuthFlows: req.AllowedOAuthFlows ?? appClient.AllowedOAuthFlows,
    AllowedOAuthFlowsUserPoolClient: req.AllowedOAuthFlowsUserPoolClient ?? appClient.AllowedOAuthFlowsUserPoolClient,
    AllowedOAuthScopes: req.AllowedOAuthScopes ?? appClient.AllowedOAuthScopes,
    AnalyticsConfiguration: req.AnalyticsConfiguration ?? appClient.AnalyticsConfiguration,
    CallbackURLs: req.CallbackURLs ?? appClient.CallbackURLs,
    ClientName: req.ClientName ?? appClient.ClientName,
    DefaultRedirectURI: req.DefaultRedirectURI ?? appClient.DefaultRedirectURI,
    EnableTokenRevocation: req.EnableTokenRevocation ?? appClient.EnableTokenRevocation,
    ExplicitAuthFlows: req.ExplicitAuthFlows ?? appClient.ExplicitAuthFlows,
    IdTokenValidity: req.IdTokenValidity ?? appClient.IdTokenValidity,
    LastModifiedDate: clock.get(),
    LogoutURLs: req.LogoutURLs ?? appClient.LogoutURLs,
    PreventUserExistenceErrors: req.PreventUserExistenceErrors ?? appClient.PreventUserExistenceErrors,
    ReadAttributes: req.ReadAttributes ?? appClient.ReadAttributes,
    RefreshTokenValidity: req.RefreshTokenValidity ?? appClient.RefreshTokenValidity,
    SupportedIdentityProviders: req.SupportedIdentityProviders ?? appClient.SupportedIdentityProviders,
    TokenValidityUnits: {
      AccessToken: ((_a = req.TokenValidityUnits) == null ? void 0 : _a.AccessToken) ?? ((_b = appClient.TokenValidityUnits) == null ? void 0 : _b.AccessToken) ?? "hours",
      IdToken: ((_c = req.TokenValidityUnits) == null ? void 0 : _c.IdToken) ?? ((_d = appClient.TokenValidityUnits) == null ? void 0 : _d.IdToken) ?? "minutes",
      RefreshToken: ((_e = req.TokenValidityUnits) == null ? void 0 : _e.RefreshToken) ?? ((_f = appClient.TokenValidityUnits) == null ? void 0 : _f.RefreshToken) ?? "days"
    },
    WriteAttributes: req.WriteAttributes ?? appClient.WriteAttributes
  });
  await userPool.saveAppClient(ctx, updatedAppClient);
  return {
    UserPoolClient: (0, import_responses.appClientToResponseObject)(updatedAppClient)
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  UpdateUserPoolClient
});
