var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  VerifyUserAttribute: () => VerifyUserAttribute
});
var import_jsonwebtoken = __toModule(require("jsonwebtoken"));
var import_errors = __toModule(require("../errors"));
var import_userPoolService = __toModule(require("../services/userPoolService"));
const VerifyUserAttribute = ({
  clock,
  cognito
}) => async (ctx, req) => {
  const decodedToken = import_jsonwebtoken.default.decode(req.AccessToken);
  if (!decodedToken) {
    ctx.logger.info("Unable to decode token");
    throw new import_errors.InvalidParameterError();
  }
  const userPool = await cognito.getUserPoolForClientId(ctx, decodedToken.client_id);
  const user = await userPool.getUserByUsername(ctx, decodedToken.sub);
  if (!user) {
    throw new import_errors.NotAuthorizedError();
  }
  if (req.Code !== user.AttributeVerificationCode) {
    throw new import_errors.CodeMismatchError();
  }
  if (req.AttributeName === "email") {
    await userPool.saveUser(ctx, __spreadProps(__spreadValues({}, user), {
      Attributes: (0, import_userPoolService.attributesAppend)(user.Attributes, (0, import_userPoolService.attribute)("email_verified", "true")),
      UserLastModifiedDate: clock.get()
    }));
  } else if (req.AttributeName === "phone_number") {
    await userPool.saveUser(ctx, __spreadProps(__spreadValues({}, user), {
      Attributes: (0, import_userPoolService.attributesAppend)(user.Attributes, (0, import_userPoolService.attribute)("phone_number_verified", "true")),
      UserLastModifiedDate: clock.get()
    }));
  } else {
  }
  return {};
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  VerifyUserAttribute
});
